package graph.extractor.graph.builder;



import org.apache.commons.lang3.StringUtils;

import dao.entity.DOProcess;
import dao.entity.Entity;
import dao.entity.Judge;
import dao.entity.Lawyer;
import dao.entity.ProcessTypes;
import dao.entity.TYPES;

public class STJBuilder extends BuilderFactory{

	private static boolean nextLawyer =false;
	
	private String normalizeJudgeName(String judgeName)
	{
		
	    judgeName = StringUtils.stripAccents(judgeName);

		
		if(judgeName.contains("(") && !judgeName.startsWith("(") )
		{

			try{

				judgeName = judgeName.split("\\(")[0].trim();
			}catch(Exception e)
			{
				e.printStackTrace();
			}
		}
		if(judgeName.contains("PRESIDENTE DA"))
		{
			
			judgeName = TYPES.NAMEDEFAULT;
		}
		if(judgeName.equals("PROCESSO NÃO DISTRIBUÍDO"))
		{
			judgeName = TYPES.NAMEDEFAULT;
		}
		
		
		return judgeName;
	}
	
	
	private String normalizeEntityName(String entityName)
	{
		
		entityName = StringUtils.stripAccents(entityName);
		
		if(entityName.contains("(PRESO)"))
		{
			entityName = entityName.split("(PRESO)")[0].trim();
		}
		if(entityName.contains("E OUTRO"))
		{
			entityName = entityName.split("E OUTRO")[0].trim();
		}
		if(entityName.endsWith(" E"))
		{
			entityName = entityName.split(" E")[0].trim();
		}
		if(entityName.endsWith("\\("))
		{
			entityName = entityName.split("\\(")[0].trim();
		}
		if(entityName.contains("ASSIST"))
		{
			
			entityName = entityName.split("ASSIST")[0].trim();
			entityName = entityName.substring(0, entityName.length() -1);
			
			
			
		}
		if(entityName.contains("CONVOCADA"))
		{
			
			entityName = entityName.split("CONVOCADA")[0].trim();
			entityName = entityName.substring(0, entityName.length() -1);
			
			
			
		}
		
		
		
		if(entityName.length() > 0)
			return entityName;
		else
			return TYPES.NAMEDEFAULT;
		
	}
	
	
	private Lawyer normalizeLawyerName(Lawyer lawyer)
	{
		
		
		
		String nameNormalized = lawyer.getName().replaceAll("\\r|\\n", " ").trim();
		nameNormalized = StringUtils.stripAccents(nameNormalized);
		
		nameNormalized = nameNormalized.replaceAll("\"", "").trim();
		nameNormalized = nameNormalized.replaceAll("/", "").trim();
		 

		try{
			
			

			if(nameNormalized.contains("-"))
			{

				if(nameNormalized.charAt(nameNormalized.length()-1) != '-')
				{
					lawyer.setOABNumber(nameNormalized.split("-")[1].trim());
				}
				nameNormalized = nameNormalized.split("-")[0].trim();
			}
			if(nameNormalized.contains("ASSIST"))
			{
				
				nameNormalized = nameNormalized.split("ASSIST")[0].trim();
				nameNormalized = nameNormalized.substring(0, nameNormalized.length() -1);
				
			}
			
			if(nameNormalized.contains("E OUTRO"))
			{
				nameNormalized = nameNormalized.split("E OUTRO")[0].trim();
			}
			
			if(nameNormalized.contains("DEFENSORIA") ||nameNormalized.contains("PROCURADORIA"))
			{
				nameNormalized = TYPES.NAMEDEFAULT;
			}
			
			if(nameNormalized.contains("EM CAUSA")  )
			{
				nameNormalized = nameNormalized.split("EM CAUSA")[0].trim();
				nameNormalized = nameNormalized.substring(0, nameNormalized.length() -1).trim();
				
			}
				
			
			if(nameNormalized.endsWith(" E"))
			{
				nameNormalized = nameNormalized.split(" E")[0].trim();
			}
			
			
			if(this.getLowerCasePCT(nameNormalized) > 70)
			{
				nameNormalized = TYPES.NAMEDEFAULT;
			}
			
			
			if(nameNormalized.equals(""))
			{
				lawyer.setName(lawyer.getName());
			}
			else
			{
				lawyer.setName(nameNormalized);
			}
			
			
			
		}
		catch(Exception e)
		{
			
			System.out.println("lawyer error:  " + lawyer);
		}


		return lawyer;
		
		
				

		
	}
	

	private Entity getEntity(String canditate)
	{



		Entity entity = new Entity();

		try{
			
			
			if(canditate.contains(":") && !canditate.contains("Distribuição automática"))
			{
				String type = canditate.split(":")[0].trim();
				entity.setType(type);
				entity.setName(this.normalizeEntityName(canditate.split(":")[1].trim()));


				if(type.equals("RELATORA") || type.equals("RELATOR"))		
				{
					entity.setType(TYPES.JUDGE);
					entity.setName(this.normalizeJudgeName(canditate.split(":")[1].trim()));
					
					
				}
				if(type.contains("ADVOGAD") || type.contains("PROCURADOR") )
				{
				
					Lawyer lawyer = this.normalizeLawyerName(new Lawyer(canditate.split(":")[1].trim()));
					entity.setName( lawyer.getName());
					if(lawyer.getOABNumber()!= null && lawyer.getOABNumber().equals(""))
					{
						entity.setOABNumber(lawyer.getOABNumber());
					}
					entity.setType(TYPES.LAWYER);
					if(type.contains("ADVOGADOS") )
						nextLawyer = true;

				}

				

			}
			else
			{
				if(nextLawyer)
				{
					nextLawyer = false;
					entity.setType(TYPES.LAWYER);
					Lawyer lawyer = this.normalizeLawyerName(new Lawyer(canditate));
					entity.setName(lawyer.getName());

				}
				else{


					entity.setName(canditate);
					entity.setType(TYPES.OTHERINFO);
				}





			}
		}catch(Exception e)
		{
			//			System.out.println(canditate);
		}

		return entity;

	}



	@Override
	protected DOProcess extractProcess(String process) {


		DOProcess proc = new DOProcess();


		proc.setOrign("DJ_STJ");

		String vecProcesses[] = process.split("\n");
		int index = 0;
		String firstLine = vecProcesses[index];

		/**Extract information from the first line**/
		try{
			if(firstLine.equals(""))
			{
				index++;
				firstLine = vecProcesses[index];
			}

			if(!firstLine.contains("class='np'"))
			{
				index++;
				firstLine = firstLine +vecProcesses[index];

			}

			if(!firstLine.contains("class='np'"))
			{
				return null;

			}



			String processType = firstLine.toLowerCase().split("nº")[0].toLowerCase();
			firstLine = firstLine.substring(processType.length());
			processType = StringUtils.stripAccents(processType);
			processType = processType.replaceAll("[^A-Za-z0-9 ]", "");

			
			ProcessTypes procType = new ProcessTypes(processType);
			proc.setProcessType(procType);



			String processIndex = firstLine.split("<NP1><B class='np'>")[0].trim();
			firstLine = firstLine.split("<NP1><B class='np'>")[1].trim();
			proc.setProcessIndex(processIndex);

			String state =  firstLine.split("\\(")[0].trim();
			firstLine = firstLine.split("\\(")[1].trim();
			proc.setState(state);

			String processNumber =  firstLine.split("\\)")[0].trim();
			firstLine = firstLine.split("\\)")[1].trim();
			proc.setProcessNumber(processNumber);


			if(!firstLine.trim().equals("</B></NP1>"))
			{

				firstLine = firstLine.split("</B></NP1>")[1].trim();
				Entity entity= this.getEntity(firstLine);

				switch (entity.getType()) {
				case TYPES.JUDGE:
					proc.setJudge(new Judge(entity.getName()));
					break;
				case TYPES.OTHERINFO:
					proc.addOtherInfo(entity.getName());
					break;
				case TYPES.LAWYER:
					proc.addLawyer(new Lawyer(entity.getName()));
					break;

				default:
					proc.addEntity(entity);
					break;
				}


			}




		}catch(Exception e)
		{
			System.out.println("Error on this process");
			System.out.println(vecProcesses[0]);
			System.out.println(proc);
			System.out.println();
			return null;
		}



		/***next lines*/
		try{
			index++;

			String line = vecProcesses[index];

			while( index < vecProcesses.length-1 && !this.isVerdict(line)  )
			{

				Entity entity= this.getEntity(line);
				
				if(entity.getName() != null)
				{
					switch (entity.getType()) {
					case TYPES.JUDGE:
						proc.setJudge(new Judge(entity.getName()));
						break;
					case TYPES.OTHERINFO:
						proc.addOtherInfo(entity.getName());
						break;
					case TYPES.LAWYER:
						proc.addLawyer(new Lawyer(entity.getName()));
						break;


					default:
						proc.addEntity(entity);
						break;
					}
				}
				

				index++;
				line = vecProcesses[index];
			}

			StringBuilder sb = new StringBuilder();

			for(int i=index; i< vecProcesses.length; i++ )
			{
				sb.append(vecProcesses[i] +"\n");

			}

			proc.setVerdict(sb.toString());




		}catch(Exception e)
		{

			e.printStackTrace();
		}

		return proc;

	}



	private double getLowerCasePCT(String line)
	{
		int lowerCaseLetters = 0;
		for (int i = 0; i < line.length(); i++) 
		{
			char ch = line.charAt(i);

			//If ch is in lowercase, then incrementing lowerCaseLetters

			if(Character.isLowerCase(ch))
			{

				lowerCaseLetters++;
			}
		}
		if( line.length() > 0)
			return 100*lowerCaseLetters/line.length();
		
		return lowerCaseLetters;
		

	}



	private boolean isVerdict(String line) {


		//System.out.println(line + " "+ this.getLowerCasePCT(line));

		if(this.getLowerCasePCT(line) > 65)
			return true;
		
		line = line.trim().toLowerCase();

		if(line.equals("despacho"))
		{

			return true;
		}
		if(line.equals("decisão"))
		{

			return true;
		}
		if(line.equals("ementa"))
		{

			return true;
		}


		if(line.contains("A Turma, por unanimidade"))
		{
			return true;
		}

		return false;
	}

}
